/*
  A class that represents one PWM output. 

  by Axel Brinkeby 
  2018-12-21
*/

#ifndef Pwmoutput_h
#define Pwmoutput_h

#include "Arduino.h"
#include <Servo.h>  // https://www.pjrc.com/teensy/td_libs_Servo.html

class Pwmoutput
{
  public: 
    Pwmoutput(); 

    void attachOnPin(int pin); 
    void setInput(int index, float amount);
    void resetAllInputs();
    void setInputValues(uint16_t channels[], float gyroData[]); 
    void updateOutput(); 
    void setMin(int value);
    void setMax(int value);
    int getMin();
    int getMax(); 
      
  private: 

    Servo _pwmOutput;       // Servo object creates PWM signals using hardware timer
    float _value;           // normalized position of the servo (range -1 to 1).
    uint16_t _minLimit;     // servo min pos in microseconds, dafault 1000.
    uint16_t _maxLimit;     // servo max pos in microseconds, dafault 2000.
    float _inputChannelMix[16];    // the mix weights for this output, how mush each inpus affects the output. 
    float _inputGyroMix[3];    // how to use the data from the gyro for this PWM output
};

#endif
